// color mixer by Frank Vloet

import processing.serial.*;
int r = 0;
int g = 0; 
int b = 0;
int max = 50;

Serial myPort;  // The serial port:

void setup() {
  // Open the port you are using at the rate you want:
  myPort = new Serial(this, "/dev/ttyUSB0", 9600);
  size(500, 500);
 
  colorMode(RGB, max);
  noStroke();
  background(r, g, b);

}

void draw() {
  while (myPort.available() > 0) {
    int inByte = myPort.read();
    //49 is int value of char 1
    //50 for 2
    //51 for 3 etc. 
    
    //subtract blue
      if (inByte == 49) {
           if (b > 0){
           b = b - 1;
           background(r, g, b);
           }
        }
    //subtract green      
      if (inByte == 50) {
           if (g > 0){  
           g = g - 1;
           background(r, g, b);
           }
        }
    //subtract red      
      if (inByte == 51) {
          if (r > 0){
           r = r - 1;
           background(r, g, b);
           }
        }
    //add blue
      if (inByte == 52) {
         if (b < max){
           b = b + 1; 
           background(r, g, b);
           }
        }
    //add green
      if (inByte == 53) {
        if (g < max){
           g = g + 1;
           background(r, g, b);
           }
        }
    //add red
      if (inByte == 54) {
        if (r < max){
           r = r + 1;
           background(r, g, b);
           }   
        }

  }
}
